Index: trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 47615)
+++ trunk/src/VBox/Frontends/VirtualBox/Makefile.kmk	(revision 47616)
@@ -387,5 +387,5 @@
 	src/widgets/VBoxOSTypeSelectorButton.h \
 	src/widgets/UINameAndSystemEditor.h \
-	src/widgets/VBoxWarningPane.h \
+    src/widgets/UIWarningPane.h \
 	src/widgets/UIFilmContainer.h \
 	src/widgets/graphics/UIGraphicsButton.h \
@@ -637,5 +637,5 @@
 	src/widgets/VBoxOSTypeSelectorButton.cpp \
 	src/widgets/UINameAndSystemEditor.cpp \
-	src/widgets/VBoxWarningPane.cpp \
+    src/widgets/UIWarningPane.cpp \
 	src/widgets/UIFilmContainer.cpp \
 	src/widgets/graphics/UIGraphicsButton.cpp \
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialog.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialog.cpp	(revision 47615)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialog.cpp	(revision 47616)
@@ -27,5 +27,5 @@
 /* Local includes */
 #include "UISettingsDialog.h"
-#include "VBoxWarningPane.h"
+#include "UIWarningPane.h"
 #include "VBoxGlobal.h"
 #include "UIMessageCenter.h"
@@ -63,5 +63,5 @@
     , m_fValid(true)
     , m_fSilent(true)
-    , m_pWarningPane(new VBoxWarningPane(this))
+    , m_pWarningPane(new UIWarningPane(this))
     /* Whats-this stuff: */
     , m_pWhatsThisTimer(new QTimer(this))
Index: trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialog.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialog.h	(revision 47615)
+++ trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsDialog.h	(revision 47616)
@@ -31,5 +31,5 @@
 class QStackedWidget;
 class QTimer;
-class VBoxWarningPane;
+class UIWarningPane;
 class VBoxSettingsSelector;
 class UISettingsPage;
@@ -143,5 +143,5 @@
     QString m_strErrorString;
     QString m_strWarningString;
-    VBoxWarningPane *m_pWarningPane;
+    UIWarningPane *m_pWarningPane;
 
     /* Whats-This stuff: */
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIWarningPane.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIWarningPane.cpp	(revision 47616)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIWarningPane.cpp	(revision 47616)
@@ -0,0 +1,68 @@
+/* $Id$ */
+/** @file
+ *
+ * VBox frontends: Qt4 GUI ("VirtualBox"):
+ * UIWarningPane class implementation
+ */
+
+/*
+ * Copyright (C) 2009-2013 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+/* Qt includes: */
+#include <QHBoxLayout>
+#include <QLabel>
+
+/* GUI includes: */
+#include "UIWarningPane.h"
+
+UIWarningPane::UIWarningPane(QWidget *pParent)
+    : QWidget(pParent)
+    , m_pLabelIcon(0)
+    , m_pLabelText(0)
+{
+    /* Prepare: */
+    prepare();
+}
+
+void UIWarningPane::setWarningPixmap(const QPixmap &pixmap)
+{
+    m_pLabelIcon->setPixmap(pixmap);
+}
+
+void UIWarningPane::setWarningText(const QString &strText)
+{
+    m_pLabelText->setText(strText);
+}
+
+void UIWarningPane::prepare()
+{
+    /* Prepare content: */
+    prepareContent();
+}
+
+void UIWarningPane::prepareContent()
+{
+    /* Create layout: */
+    QHBoxLayout *pLayout = new QHBoxLayout(this);
+    {
+        /* Configure layout: */
+        pLayout->setContentsMargins(0, 0, 0, 0);
+        /* Create icon label: */
+        m_pLabelIcon = new QLabel;
+        /* Create text label: */
+        m_pLabelText = new QLabel;
+        /* Add widgets into layout: */
+        pLayout->addWidget(m_pLabelIcon);
+        pLayout->addWidget(m_pLabelText);
+    }
+}
+
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIWarningPane.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIWarningPane.h	(revision 47616)
+++ trunk/src/VBox/Frontends/VirtualBox/src/widgets/UIWarningPane.h	(revision 47616)
@@ -0,0 +1,53 @@
+/** @file
+ *
+ * VBox frontends: Qt4 GUI ("VirtualBox"):
+ * UIWarningPane class declaration
+ */
+
+/*
+ * Copyright (C) 2009-2013 Oracle Corporation
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ */
+
+#ifndef __UIWarningPane_h__
+#define __UIWarningPane_h__
+
+/* Global includes */
+#include <QWidget>
+
+/* Forward declarations: */
+class QLabel;
+
+/* Warning-pane prototype: */
+class UIWarningPane: public QWidget
+{
+    Q_OBJECT;
+
+public:
+
+    /* Constructor: */
+    UIWarningPane(QWidget *pParent = 0);
+
+    /* API: Warning stuff: */
+    void setWarningPixmap(const QPixmap &pixmap);
+    void setWarningText(const QString &strText);
+
+private:
+
+    /* Helpers: Prepare stuff: */
+    void prepare();
+    void prepareContent();
+
+    /* Variables: Widgets: */
+    QLabel *m_pLabelIcon;
+    QLabel *m_pLabelText;
+};
+
+#endif /* __UIWarningPane_h__ */
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxWarningPane.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxWarningPane.cpp	(revision 47615)
+++ 	(revision )
@@ -1,44 +1,0 @@
-/* $Id$ */
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * VBoxWarningPane class implementation
- */
-
-/*
- * Copyright (C) 2009-2011 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-/* Global includes */
-#include <QHBoxLayout>
-
-/* Local includes */
-#include "VBoxWarningPane.h"
-
-VBoxWarningPane::VBoxWarningPane(QWidget *pParent)
-    : QWidget(pParent)
-{
-    QHBoxLayout *pLayout = new QHBoxLayout(this);
-    pLayout->setContentsMargins(0, 0, 0, 0);
-    pLayout->addWidget(&m_icon);
-    pLayout->addWidget(&m_label);
-}
-
-void VBoxWarningPane::setWarningPixmap(const QPixmap &imgPixmap)
-{
-    m_icon.setPixmap(imgPixmap);
-}
-
-void VBoxWarningPane::setWarningText(const QString &strText)
-{
-    m_label.setText(strText);
-}
-
Index: trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxWarningPane.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/widgets/VBoxWarningPane.h	(revision 47615)
+++ 	(revision )
@@ -1,44 +1,0 @@
-/** @file
- *
- * VBox frontends: Qt4 GUI ("VirtualBox"):
- * VBoxWarningPane class declaration
- */
-
-/*
- * Copyright (C) 2009-2010 Oracle Corporation
- *
- * This file is part of VirtualBox Open Source Edition (OSE), as
- * available from http://www.virtualbox.org. This file is free software;
- * you can redistribute it and/or modify it under the terms of the GNU
- * General Public License (GPL) as published by the Free Software
- * Foundation, in version 2 as it comes in the "COPYING" file of the
- * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
- * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
- */
-
-#ifndef __VBoxWarningPane_h__
-#define __VBoxWarningPane_h__
-
-/* Global includes */
-#include <QWidget>
-#include <QLabel>
-
-class VBoxWarningPane: public QWidget
-{
-    Q_OBJECT;
-
-public:
-
-    VBoxWarningPane(QWidget *pParent = 0);
-
-    void setWarningPixmap(const QPixmap &imgPixmap);
-    void setWarningText(const QString &strText);
-
-private:
-
-    QLabel m_icon;
-    QLabel m_label;
-};
-
-#endif // __VBoxWarningPane_h__
-